/* Copyright (c) 2000-2001 ActiveState SRL. 
   See the file LICENSE.txt for licensing information. */

/* Komodo's Tutorial UI support.
 */


//---- globals


//---- internal support routines

function _InKomodoHelp()
{
    if (navigator.appName.substring(0,8) == "Netscape" &&
        navigator.appVersion.substring(0,1) >= "5")
    {
        try {
            var windowManager = Components.classes[
                "@mozilla.org/appshell/window-mediator;1"].
                getService(Components.interfaces.nsIWindowMediator);
        } catch (e) {
            // This is Mozilla but the content is not running under chrome,
            // hence a component could not be created.
            return false;
        }
        return true;
    } else {
        // This is not Mozilla.
        return false;
    }
}



//---- interface for the tutorial HTML files


function SetupForTutorial(language)
{
    try {
        if (!_InKomodoHelp()) {
            alert("You must view this HTML page in Komodo's Help browser to run this link.");
            return false;
        }

        var tutSvc = Components.classes["@activestate.com/ko"+language+"TutorialService;1"]
                     .getService(Components.interfaces.koITutorialService);

        // Determine a default working copy dir.
        var workingDir = tutSvc.GetWorkingDir();

        // Ask the user for an alternate location.
        var errorStr = "";
        while (1) {
            var message = "";
            if (errorStr) {
                message += errorStr + "\n\n";
            }
            message += "Enter a working directory for this tutorial. A "+
                       "project with tutorial files will be created here.";
            var retval = dialog_prompt(message, "Working Directory:",
                                       workingDir, "Setup Tutorial Files");
            if (retval == null) {
                // Return false to have the <a/> link NOT be followed.
                return false;
            } else {
                workingDir = retval;
                // Create the temp directory and copy over the files (making them
                // writeable).
                errorStr = tutSvc.PrepareWorkingDir(workingDir);
                if (!errorStr) {
                    break;
                }
            }
        }

        // Open the project in Komodo.
        var osPath = Components.classes["@activestate.com/koOsPath;1"].
                     getService(Components.interfaces.koIOsPath);
        var projectPath = osPath.join(workingDir, tutSvc.projectFileName);
        var observerSvc = Components.classes["@mozilla.org/observer-service;1"].
                          getService(Components.interfaces.nsIObserverService);
        try {
            observerSvc.notifyObservers(null, "open_file", projectPath);
        } catch (ex) {
            // Do not fail if there are no observers of this notification.
        }

        // Return false to have the <a/> link NOT be followed.
        return false;
    } catch (ex) {
        try {
            dialog_internalError("Unknown error setting up for tutorial.",
                                 ex);
        } catch(ex2) {
            // Protect against not even having dialog_internalError() which
            // will happen if the tutorial HTML dialog not have the proper .js
            // includes.
            alert("Error setting up for tutorial: "+ex2);
        }
    }
}

