var scin;
var _genericController;

function OnLoad() {
    var text, lexer, language, editor, prefs;
    
    trace_onload();
    command_onload();
    // "steal" the commands and keyset from the main window
    // Doing it the 'right' way takes a long time - I'm hoping this
    // will be faster.
    document.getElementById('komodo-buffer').
        appendChild(opener.document.getElementById('allcommands').
                    cloneNode(1));
    window.title = window.arguments[0].title;
    editor = document.getElementById('editor');
    editor.init();
    if (!'language' in window.arguments[0] ||
        !window.arguments[0].language) {
        opener.log.error('The text was not specified for editor.xul');
        text = '';
    } else {
        text = window.arguments[0].text;
    }
    if (!'language' in window.arguments[0] ||
        !window.arguments[0].language) {
        opener.log.error('The language was not specified for editor.xul');
        language = 'Text';
    } else {
        language = window.arguments[0].language;
    }
    try {
        this._document = editor.docSvc.createUntitledDocument(language);
        this._document.addView(editor);
        this._document.buffer = text;
        editor.initWithBuffer(text, language);
        editor.encoding = this._document.encoding.python_encoding_name;
        editor.scimoz.codePage = this._document.codePage;
        this._languageObj = this._document.languageObj;
        editor.setFocus();
    } catch(e) {
        opener.log.exception(e);
    }
    scin = editor.scimoz;
    if ("processDiffs" in window.arguments[0] && window.arguments[0].processDiffs) {
        processDiffRanges(text);
        document.getElementById('diff_shortcuts').removeAttribute('collapsed');
        nextDiff();
    }
}

function OnUnload()
{
}

// For diff windows, we support finding of the next and previous
// "segments".

var rangeStarts;
var rangeEnds;
function processDiffRanges(text) {
    rangeStarts = new Array();
    rangeEnds = new Array();
    var lines = text.split(/\r\n|\n|\r/);
    var start1 = lines[0].slice(0, 1)
    var start2 = lines[0].slice(0, 2)
    var inDiff = start1 == '+' || start1 == '-' || start2 == '? ' || start2 == '< ' || start2 == '> ' || start2 == '--';
    if (inDiff) {
        rangeStarts.push(0);
    }
    for (var i = 0; i < lines.length; i++) {
        start1 = lines[i].slice(0,1);
        start2 = lines[i].slice(0,2);
        if (start1.length != 1) continue;
        if (start2.length != 2) continue;
        if (inDiff) {
            if (!(start1 == '+' || start1 == '-' || start2 == '? ' || start2 == '< ' || start2 == '> ' || start2 == '--')) {
                rangeEnds.push(i);
                inDiff = false;
            }
        } else {
            if (start1 == '+' || start1 == '-' || start2 == '? ' || start2 == '< ' || start2 == '> ' || start2 == '--') {
                rangeStarts.push(i);
                inDiff = true;
            }
        }
    }
    if (inDiff) {
        rangeEnds.push(lines.length);
    }
}

function nextDiff() {
    if (!rangeStarts) return; // If this is not a diff window
    var curLine = scin.lineFromPosition(scin.selectionEnd);
    var i;
    var diffStartLine = -1;
    var diffEndLine = 0;
    for (i = 0; i < rangeStarts.length; i++) {
        if (rangeStarts[i] >= curLine) {
            diffStartLine = rangeStarts[i];
            break;
        }
    }
    if (diffStartLine == -1) return;
    for (i = 0; i < rangeEnds.length; i++) {
        if (rangeEnds[i] > diffStartLine) {
            diffEndLine = rangeEnds[i];
            break;
        }
    }
    scin.selectionStart = Math.min(scin.positionFromLine(diffStartLine), scin.text.length);
    scin.selectionEnd = Math.min(scin.positionFromLine(diffEndLine), scin.text.length);
    scin.ensureVisible(diffEndLine);
    scin.ensureVisibleEnforcePolicy(diffEndLine);
    scin.ensureVisible(diffStartLine);
    scin.ensureVisibleEnforcePolicy(diffStartLine);
}

function previousDiff() {
    if (!rangeStarts) return; // If this is not a diff window
    var curLine = scin.lineFromPosition(scin.selectionStart);
    var i;
    var diffStartLine = -1;
    var diffEndLine = curLine + 1;
    for (i = rangeEnds.length-1; i >= 0; i--) {
        if (rangeEnds[i] < diffEndLine) {
            diffEndLine = rangeEnds[i];
            break;
        }
    }
    if (i == -1) return;
    for (i = rangeStarts.length-1; i >= 0; i--) {
        if (rangeStarts[i] < diffEndLine) {
            diffStartLine = rangeStarts[i];
            break;
        }
    }
    scin.selectionStart = scin.positionFromLine(diffStartLine);
    scin.selectionEnd = scin.positionFromLine(diffEndLine);
    scin.ensureVisible(diffEndLine);
    scin.ensureVisibleEnforcePolicy(diffStartLine);
}
