/* Copyright (c) 2000-2001 ActiveState Corporation.
   See the file LICENSE.txt for licensing information. */

/* Properties of the argument object (window.argumnets[0]) to this window are:
    type -'add' or 'edit' of a bookmark
    url -
    retval - boolean value for ok/cancel
    When type is add only:
    name
    description -
    shortname -
    When type is edit only:
    dir - 
*/
    
// Globals
var os = Components.classes["@activestate.com/koOs;1"].getService();
var shortnameBox, urlBox, descBox, nameBox;

var dialog;
var wslog = getLoggingMgr().getLogger('ws.properties');
wslog.setLevel(LOG_DEBUG);

function bmedit_onLoad()  {
    try {
        dialog = {};
        dialog.shortnameBox = document.getElementById('shortnameBox');
        dialog.urlBox = document.getElementById('urlBox');
        dialog.descBox = document.getElementById('descBox');
        dialog.nameBox = document.getElementById('nameBox');
        dialog.suggestBtn = document.getElementById('suggestBtn');
    
        if (window.arguments[0].type == 'edit')  {
            dialog.nameBox.value = window.arguments[0].name;
            dialog.urlBox.value = window.arguments[0].url;
            bmedit_writeDesc(window.arguments[0].description);
            dialog.shortnameBox.value = window.arguments[0].shortname;
            window.title = "Edit Bookmark";
        }
        else  {
            window.title = "Add Bookmark";
            bmedit_writeDesc('');
        }
        
        if (window.arguments[0].url != null) 
            dialog.urlBox.value = window.arguments[0].url;
    
        dialog.urlBox.focus();
    
        bmedit_updateButtonState();
        window.sizeToContent();
        var dlg = document.getElementById("wsBookmarksEditWindow")
        if (opener.innerHeight == 0) { // indicator that opener hasn't loaded yet
            dlg.centerWindowOnScreen();
        } else {
            dlg.moveToAlertPosition(); // requires a loaded opener
        }
    } catch(e) {
        wslog.exception(e);
    }
}

function bmedit_writeDesc(desc) {
    var bmdesc = window.frames[0].document;
    bmdesc.open();
    bmdesc.write('<BODY STYLE="background-color: -moz-Dialog;">');
    bmdesc.write('<FONT FACE="tahoma, arial" STYLE="font-size: 11px;">');
    bmdesc.write(desc);
    bmdesc.write('</FONT>');
    bmdesc.write('</BODY>');
    bmdesc.close();
    dialog.descBox.value = desc;
}

function bmedit_onUnLoad()  {

}

function bmedit_onOk()  {
    var bmark = window.arguments[0].bmark;
    if (!bmark)
        bmark = bmedit_createBookmark();
    if (!bmark) {
        wslog.error('Unable to create a bookmark!');
        return false;
    }
    window.arguments[0].name = dialog.nameBox.value;
    window.arguments[0].url = dialog.urlBox.value;
    window.arguments[0].description = dialog.descBox.value;
    window.arguments[0].shortname= dialog.shortnameBox.value;
    window.arguments[0].retval = true;
    window.arguments[0].bmark = bmark;
    return true;
}

function bmedit_onCancel()  {
    return true;
}

function bmedit_updateButtonState() {

    if (dialog.urlBox.value) {
        dialog.suggestBtn.removeAttribute('disabled');
    } else {
        dialog.suggestBtn.setAttribute('disabled', 'true');
    }
}

function bmedit_createBookmark()  {
    // construct the file name
    var path;
    if (dialog.nameBox.value == "" || dialog.urlBox.value == "") {
        return false;
    }
    window.setCursor("spinning");
    var bmark = null;
    try {
        bmark = Components.classes["@activestate.com/koBookmark;1"].createInstance(Components.interfaces.koIBookmark);
        bmark.url = dialog.urlBox.value;
        bmark.name = dialog.nameBox.value;
        bmark.description = dialog.descBox.value;
        bmark.shortname = dialog.shortnameBox.value;
        var errmsg = new Object();
        var success = bmark.save(bmark.name, false, errmsg);
        if (errmsg.value) {
            window.setCursor("auto");
            opener.dialog_alert(errmsg.value);
            return null;
        }
    } catch(e) {
        wslog.exception(e);
    }
    window.setCursor("auto");
    return bmark    
}

function bmedit_suggestDetails() {
    window.setCursor("spinning");
    // get details from the wsdl if possible
    var bmark = null;
    try {
        bmark = Components.classes["@activestate.com/koBookmark;1"].createInstance(Components.interfaces.koIBookmark);
        bmark.url = dialog.urlBox.value;
        var errmsg = new Object();
        var success = bmark.generateFromWSDL(errmsg);
        if (!success) {
            window.setCursor("auto");
            alert("Error retrieving " + bmark.url + ".  " + errmsg.value);
            return;
        }
        
        dialog.nameBox.value = bmark.name;
        bmedit_writeDesc(bmark.description);
        dialog.shortnameBox.value = bmark.shortname;
        bmedit_updateButtonState();
    } catch (e) {
        wslog.exception(e);
    }
    window.setCursor("auto");
    if (bmark)
        window.arguments[0].bmark = bmark;
}
