/* Copyright (c) 2000-2001 ActiveState Corporation.
 * See the file LICENSE.txt for licensing information.
 *
 * This sample JavaScript program shows you some of the features in
 * Komodo to help you work with your JavaScript code.
 */

function validateForm(form) {
    var pass = true;
    for (i = 0; i < form.length; i++) {
        var element = form.elements[i];
        if (element.name.substring(0,8) == "required") {
            if (((element.type=="text" || element.type=="textarea") &&
                  element.value=='') && element.selectedIndex==0) {
                pass = false;
                break;
            }
        }
    }
    if (!pass) {
        shortName = element.name.substring(8,30).toUpperCase();
        alert("Please complete the " + shortName + " field correctly.");
        return false;
    }
    else {
        return true;
    }
}

/* Code Folding
 *  The following JavaScript code shows a possible example of HTML
 *  form validation if included in an HTML form like this:
 *       <form onSubmit="return validateForm(this)">
 *          <!-- ... -->
 *       </form>
 *
 *  You can collapse and expand blocks of code. Click the "-" and "+"
 *  signs in the light grey bar on the left.
 */

/* Syntax Coloring:
 *  Komodo detects keywords and applies syntax coloring. In the code
 *  above, note how "if" is a different color from "shortname" on the
 *  next line, which is a different color from "return" on the next
 *  line.
 */

/* Background Syntax Checking:
 *  Komodo periodically checks for syntax errors in your JavaScript
 *  code as you type.  Komodo underlines syntax errors in red and
 *  green "squiggles".  For example, uncomment the following line of
 *  code. The red squiggle indicates the error. Put your cursor over
 *  the squiggle to see the actual error message in the status bar.
 */

//ar myvariable = 1;  /* oops, left off the "v" in var */


/* See Komodo's online help for much more information on:
 *   - managing projects
 *   - keyboard shortcuts
 *   - remote debugging; and more
 * Just press <F1>, or select Help from the Help menu.
 */
